/*
Copyright 2023 Bonitasoft S.A.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
import { BpmnVisualization as BaseBpmnVisualization } from 'bpmn-visualization';
export class BpmnVisualization extends BaseBpmnVisualization {
    constructor(options) {
        super(options);
        Object.defineProperty(this, "plugins", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new Map()
        });
        Object.defineProperty(this, "registerPlugins", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: (options) => {
                var _a, _b;
                // construct
                for (const constructor of (_a = options.plugins) !== null && _a !== void 0 ? _a : []) {
                    const plugin = new constructor(this, options);
                    const pluginId = plugin.getPluginId();
                    if (this.plugins.has(pluginId)) {
                        throw new Error(`Plugin loading fails. It is not possible to register multiple plugins with the same '${pluginId}' identifier.`);
                    }
                    this.plugins.set(pluginId, plugin);
                }
                // configure
                for (const plugin of this.plugins.values()) {
                    (_b = plugin.configure) === null || _b === void 0 ? void 0 : _b.call(plugin, options);
                }
            }
        });
        this.registerPlugins(options);
    }
    getPlugin(id) {
        return this.plugins.get(id);
    }
}
