import type { BpmnVisualization, Plugin } from '../plugins-support.js';
import type { CssClassesRegistry } from 'bpmn-visualization';
/**
 * Provide CSS classes operations on BPMN elements.
 *
 * This plugin is a wrapper that delegates the actual CSS classes operations to {@link BpmnElementsRegistry}.
 *
 * @since 0.7.0
 */
export declare class CssClassesPlugin implements Plugin, CssClassesRegistry {
    private readonly cssRegistry;
    constructor(bpmnVisualization: BpmnVisualization);
    getPluginId(): string;
    addCssClasses(bpmnElementIds: string | string[], classNames: string | string[]): void;
    removeCssClasses(bpmnElementIds: string | string[], classNames: string | string[]): void;
    removeAllCssClasses(bpmnElementIds?: string | string[]): void;
    toggleCssClasses(bpmnElementIds: string | string[], classNames: string | string[]): void;
}
